<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>documentation/info_segments/file_manager_.info</title>
<meta name="Generator" content="Vim/9.1">
<meta name="plugin-version" content="vim9.0_v2">
<meta name="syntax" content="none">
<meta name="settings" content="number_lines,use_css,no_foldcolumn,expand_tabs,line_ids,pre_wrap,prevent_copy=,use_input_for_pc=none">
<meta name="colorscheme" content="PaperColor">
<style>
<!--
pre { white-space: pre-wrap; font-family: monospace; color: #d0d0d0; background-color: #000000; }
body { font-family: monospace; color: #d0d0d0; background-color: #000000; }
* { font-size: 1em; }
.textRainbow_lv1_p0 { color: #ffffe0; }
.textRainbow_lv0_o0 { color: #add8e6; }
.textRainbow_lv0_p0 { color: #add8e6; }
.LineNr { color: #585858; }
-->
</style>

<script>
<!--

/* function to open any folds containing a jumped-to line before jumping to it */
function JumpToLine()
{
  var lineNum;
  lineNum = window.location.hash;
  lineNum = lineNum.substr(1); /* strip off '#' */

  if (lineNum.indexOf('L') == -1) {
    lineNum = 'L'+lineNum;
  }
  var lineElem = document.getElementById(lineNum);
  /* Always jump to new location even if the line was hidden inside a fold, or
   * we corrected the raw number to a line ID.
   */
  if (lineElem) {
    lineElem.scrollIntoView(true);
  }
  return true;
}
if ('onhashchange' in window) {
  window.onhashchange = JumpToLine;
}

-->
</script>
</head>
<body onload='JumpToLine();'>
<pre id='vimCodeElement'>
<span id="L1" class="LineNr">  1 </span>03/15/85  file_manager_
<span id="L2" class="LineNr">  2 </span>
<span id="L3" class="LineNr">  3 </span>
<span id="L4" class="LineNr">  4 </span>The file_manager_ subroutine is the interface between the data storage
<span id="L5" class="LineNr">  5 </span>and retrieval services of data management and Multics file access and
<span id="L6" class="LineNr">  6 </span>control mechanisms.  It also ensures concurrency and recovery
<span id="L7" class="LineNr">  7 </span>protection by invoking data management integrity services when
<span id="L8" class="LineNr">  8 </span>protected data management <span class="textRainbow_lv0_p0">(</span>DM<span class="textRainbow_lv0_p0">)</span> files are accessed or modified.
<span id="L9" class="LineNr">  9 </span>
<span id="L10" class="LineNr"> 10 </span>As a direct user interface, the file_manager_ subroutine makes the
<span id="L11" class="LineNr"> 11 </span>protection and recovery capabilities of integrity services available to
<span id="L12" class="LineNr"> 12 </span>users who write applications using their own data storage and retrieval
<span id="L13" class="LineNr"> 13 </span>software.
<span id="L14" class="LineNr"> 14 </span>
<span id="L15" class="LineNr"> 15 </span>
<span id="L16" class="LineNr"> 16 </span>Entry points in file_manager_:
<span id="L17" class="LineNr"> 17 </span>   <span class="textRainbow_lv0_p0">(</span>List is generated by the help command<span class="textRainbow_lv0_p0">)</span>
<span id="L18" class="LineNr"> 18 </span>
<span id="L19" class="LineNr"> 19 </span>
<span id="L20" class="LineNr"> 20 </span>:Entry:  close:  03/15/85 file_manager_$close
<span id="L21" class="LineNr"> 21 </span>
<span id="L22" class="LineNr"> 22 </span>
<span id="L23" class="LineNr"> 23 </span>Function:  This entry point closes a DM file in the current process.
<span id="L24" class="LineNr"> 24 </span>The file to be closed is designated by its opening identifier.
<span id="L25" class="LineNr"> 25 </span>
<span id="L26" class="LineNr"> 26 </span>
<span id="L27" class="LineNr"> 27 </span>Syntax:
<span id="L28" class="LineNr"> 28 </span>declare file_manager_$close entry <span class="textRainbow_lv0_p0">(</span>bit<span class="textRainbow_lv1_p0">(</span>36<span class="textRainbow_lv1_p0">)</span> aligned<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L29" class="LineNr"> 29 </span>call file_manager_$close <span class="textRainbow_lv0_p0">(</span>oid<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L30" class="LineNr"> 30 </span>
<span id="L31" class="LineNr"> 31 </span>
<span id="L32" class="LineNr"> 32 </span>Arguments:
<span id="L33" class="LineNr"> 33 </span>oid
<span id="L34" class="LineNr"> 34 </span>   is the file opening identifier of the file to be closed.
<span id="L35" class="LineNr"> 35 </span>   <span class="textRainbow_lv0_p0">(</span>Input/Output<span class="textRainbow_lv0_p0">)</span> It is set to zero by this entry point in order to
<span id="L36" class="LineNr"> 36 </span>   indicate that it is no longer valid.
<span id="L37" class="LineNr"> 37 </span>code
<span id="L38" class="LineNr"> 38 </span>   is a standard status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L39" class="LineNr"> 39 </span>
<span id="L40" class="LineNr"> 40 </span>
<span id="L41" class="LineNr"> 41 </span>Notes:  If the file is opened more than once in the process, this
<span id="L42" class="LineNr"> 42 </span>operation decreases the number of openings by one.  See the description
<span id="L43" class="LineNr"> 43 </span>of the open entry for more details.
<span id="L44" class="LineNr"> 44 </span>
<span id="L45" class="LineNr"> 45 </span>The user process does not have to be in transaction mode to close a DM
<span id="L46" class="LineNr"> 46 </span>file.  Aborting a transaction does not cause the file to be reopened,
<span id="L47" class="LineNr"> 47 </span>even if it was closed by a delete_close operation and the deletion was
<span id="L48" class="LineNr"> 48 </span>rolled back.
<span id="L49" class="LineNr"> 49 </span>
<span id="L50" class="LineNr"> 50 </span>
<span id="L51" class="LineNr"> 51 </span>:Entry:  create:  03/15/85 file_manager_$create
<span id="L52" class="LineNr"> 52 </span>
<span id="L53" class="LineNr"> 53 </span>
<span id="L54" class="LineNr"> 54 </span>Function:  This entry point creates a DM file.  The caller specifies
<span id="L55" class="LineNr"> 55 </span>its pathname and attributes, and must specify whether the file is
<span id="L56" class="LineNr"> 56 </span>protected; see &quot;Notes&quot; below.
<span id="L57" class="LineNr"> 57 </span>
<span id="L58" class="LineNr"> 58 </span>
<span id="L59" class="LineNr"> 59 </span>Syntax:
<span id="L60" class="LineNr"> 60 </span>declare file_manager_$create <span class="textRainbow_lv0_p0">(</span>char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L61" class="LineNr"> 61 </span>call file_manager_$create <span class="textRainbow_lv0_p0">(</span>dir_path<span class="textRainbow_lv0_o0">,</span> entry_name<span class="textRainbow_lv0_o0">,</span> file_create_info_ptr<span class="textRainbow_lv0_o0">,</span>
<span id="L62" class="LineNr"> 62 </span>     code<span class="textRainbow_lv0_p0">)</span>;
<span id="L63" class="LineNr"> 63 </span>
<span id="L64" class="LineNr"> 64 </span>
<span id="L65" class="LineNr"> 65 </span>Arguments:
<span id="L66" class="LineNr"> 66 </span>dir_path
<span id="L67" class="LineNr"> 67 </span>   is the absolute pathname of a directory.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> The file will be
<span id="L68" class="LineNr"> 68 </span>   added to this directory.
<span id="L69" class="LineNr"> 69 </span>entry_name
<span id="L70" class="LineNr"> 70 </span>   is the name of the file.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L71" class="LineNr"> 71 </span>file_create_info_ptr
<span id="L72" class="LineNr"> 72 </span>   points to the file_create_info structure.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> If
<span id="L73" class="LineNr"> 73 </span>   this pointer is null, a protected file is created with the default
<span id="L74" class="LineNr"> 74 </span>   attribute values.
<span id="L75" class="LineNr"> 75 </span>code
<span id="L76" class="LineNr"> 76 </span>   is a standard status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L77" class="LineNr"> 77 </span>
<span id="L78" class="LineNr"> 78 </span>
<span id="L79" class="LineNr"> 79 </span>Access required:
<span id="L80" class="LineNr"> 80 </span>You cannot create a DM file in your home directory unless you have the
<span id="L81" class="LineNr"> 81 </span>proper access to the directory above the containing directory, and, in
<span id="L82" class="LineNr"> 82 </span>any event, you must have sufficient access to add an entry to the
<span id="L83" class="LineNr"> 83 </span>containing directory.  The file is created with read and write access
<span id="L84" class="LineNr"> 84 </span>for the caller and the DM daemon <span class="textRainbow_lv0_p0">(</span>Data_Management.Daemon<span class="textRainbow_lv0_p0">)</span>.
<span id="L85" class="LineNr"> 85 </span>
<span id="L86" class="LineNr"> 86 </span>
<span id="L87" class="LineNr"> 87 </span>Notes:  In the current implementation, file attributes specified in the
<span id="L88" class="LineNr"> 88 </span>file_create_info structure such as ring brackets and blocking factor
<span id="L89" class="LineNr"> 89 </span>cannot be changed.
<span id="L90" class="LineNr"> 90 </span>
<span id="L91" class="LineNr"> 91 </span>
<span id="L92" class="LineNr"> 92 </span>:Entry:  create_open:  03/15/85 file_manager_$create_open
<span id="L93" class="LineNr"> 93 </span>
<span id="L94" class="LineNr"> 94 </span>
<span id="L95" class="LineNr"> 95 </span>Function:  Calling this entry point has the effect of calling the
<span id="L96" class="LineNr"> 96 </span>create and open entries, but is more efficient.  If the file already
<span id="L97" class="LineNr"> 97 </span>exists, it is opened and code is dm_error_$file_already_exists.  If the
<span id="L98" class="LineNr"> 98 </span>file already exists and is already open, the opening identifier is
<span id="L99" class="LineNr"> 99 </span>returned and code is dm_error_$file_already_open.
<span id="L100" class="LineNr">100 </span>
<span id="L101" class="LineNr">101 </span>
<span id="L102" class="LineNr">102 </span>Syntax:
<span id="L103" class="LineNr">103 </span>declare file_manager_$create_open entry <span class="textRainbow_lv0_p0">(</span>char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span> bit<span class="textRainbow_lv1_p0">(</span>36<span class="textRainbow_lv1_p0">)</span>
<span id="L104" class="LineNr">104 </span>     aligned<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L105" class="LineNr">105 </span>call file_manager_$create_open <span class="textRainbow_lv0_p0">(</span>dir_path<span class="textRainbow_lv0_o0">,</span> entry_name<span class="textRainbow_lv0_o0">,</span>
<span id="L106" class="LineNr">106 </span>     file_create_info_ptr<span class="textRainbow_lv0_o0">,</span> oid<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L107" class="LineNr">107 </span>
<span id="L108" class="LineNr">108 </span>
<span id="L109" class="LineNr">109 </span>Arguments:
<span id="L110" class="LineNr">110 </span>dir_path
<span id="L111" class="LineNr">111 </span>   is the absolute pathname of a directory.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> The file is added
<span id="L112" class="LineNr">112 </span>   to this directory.
<span id="L113" class="LineNr">113 </span>entry_name
<span id="L114" class="LineNr">114 </span>   is the name of the file.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L115" class="LineNr">115 </span>file_create_info_ptr
<span id="L116" class="LineNr">116 </span>   is a pointer to a file_create_info structure into which the file
<span id="L117" class="LineNr">117 </span>   attributes are to be placed.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> This structure may in turn be
<span id="L118" class="LineNr">118 </span>   used to create a new DM file into which to copy the old DM file.
<span id="L119" class="LineNr">119 </span>   The structure is defined in dm_fm_create_info.incl.pl1.
<span id="L120" class="LineNr">120 </span>
<span id="L121" class="LineNr">121 </span>
<span id="L122" class="LineNr">122 </span>oid
<span id="L123" class="LineNr">123 </span>   is the opening identifier assigned to the file.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span> If it is
<span id="L124" class="LineNr">124 </span>   not zero, the oid is valid and can be used, regardless of the value
<span id="L125" class="LineNr">125 </span>   of code.  If the transaction aborts and the file is deleted, it
<span id="L126" class="LineNr">126 </span>   still needs to be closed, since openings are not undone by rollback.
<span id="L127" class="LineNr">127 </span>code
<span id="L128" class="LineNr">128 </span>   is a standard status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span> If it is
<span id="L129" class="LineNr">129 </span>   dm_error_$file_already_exists or dm_error_$file_already_open, the
<span id="L130" class="LineNr">130 </span>   operation is considered successful and oid is usable.
<span id="L131" class="LineNr">131 </span>
<span id="L132" class="LineNr">132 </span>
<span id="L133" class="LineNr">133 </span>:Entry:  delete_close:  03/15/85 file_manager_$delete_close
<span id="L134" class="LineNr">134 </span>
<span id="L135" class="LineNr">135 </span>
<span id="L136" class="LineNr">136 </span>Function:  Calling this entry point has the same effect as calling the
<span id="L137" class="LineNr">137 </span>delete and close entries, but is more efficient.  It deletes a file
<span id="L138" class="LineNr">138 </span>that is already open.
<span id="L139" class="LineNr">139 </span>
<span id="L140" class="LineNr">140 </span>
<span id="L141" class="LineNr">141 </span>Syntax:
<span id="L142" class="LineNr">142 </span>declare file_manager_$delete_close entry <span class="textRainbow_lv0_p0">(</span>bit<span class="textRainbow_lv1_p0">(</span>36<span class="textRainbow_lv1_p0">)</span> aligned<span class="textRainbow_lv0_o0">,</span> fixed
<span id="L143" class="LineNr">143 </span>     bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L144" class="LineNr">144 </span>call file_manager_$delete_close <span class="textRainbow_lv0_p0">(</span>oid<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L145" class="LineNr">145 </span>
<span id="L146" class="LineNr">146 </span>
<span id="L147" class="LineNr">147 </span>Arguments:
<span id="L148" class="LineNr">148 </span>oid
<span id="L149" class="LineNr">149 </span>   is the file opening identifier of the file to be deleted and closed.
<span id="L150" class="LineNr">150 </span>   <span class="textRainbow_lv0_p0">(</span>Input/Output<span class="textRainbow_lv0_p0">)</span> It is set to zero by this entry point in order to
<span id="L151" class="LineNr">151 </span>   indicate that it is no longer valid.  The file remains closed even
<span id="L152" class="LineNr">152 </span>   if the transaction is aborted, negating the delete operation.
<span id="L153" class="LineNr">153 </span>code
<span id="L154" class="LineNr">154 </span>   is a standard status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L155" class="LineNr">155 </span>
<span id="L156" class="LineNr">156 </span>
<span id="L157" class="LineNr">157 </span>:Entry:  free:  03/15/85 file_manager_$free
<span id="L158" class="LineNr">158 </span>
<span id="L159" class="LineNr">159 </span>
<span id="L160" class="LineNr">160 </span>Function:  This entry point frees disk space allocated to control
<span id="L161" class="LineNr">161 </span>intervals.  The set of consecutive control intervals is specified by
<span id="L162" class="LineNr">162 </span>the number of the first control interval and the number of consecutive
<span id="L163" class="LineNr">163 </span>control intervals starting at the first one.  After the disk space for
<span id="L164" class="LineNr">164 </span>a control interval has been freed, its content is effectively zero.
<span id="L165" class="LineNr">165 </span>This operation has a high fixed overhead, so it should not be called
<span id="L166" class="LineNr">166 </span>for one control interval at a time.
<span id="L167" class="LineNr">167 </span>
<span id="L168" class="LineNr">168 </span>If any or all of the control intervals are already free, code is set to
<span id="L169" class="LineNr">169 </span>dm_error_$ci_already_free.  The operation is, nevertheless, successful.
<span id="L170" class="LineNr">170 </span>
<span id="L171" class="LineNr">171 </span>
<span id="L172" class="LineNr">172 </span>Syntax:
<span id="L173" class="LineNr">173 </span>declare file_manager_$free entry <span class="textRainbow_lv0_p0">(</span>bit<span class="textRainbow_lv1_p0">(</span>36<span class="textRainbow_lv1_p0">)</span> aligned<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>27<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed
<span id="L174" class="LineNr">174 </span>     bin<span class="textRainbow_lv1_p0">(</span>27<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L175" class="LineNr">175 </span>call file_manager_$free <span class="textRainbow_lv0_p0">(</span>oid<span class="textRainbow_lv0_o0">,</span> first_ci<span class="textRainbow_lv0_o0">,</span> n_ci<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L176" class="LineNr">176 </span>
<span id="L177" class="LineNr">177 </span>
<span id="L178" class="LineNr">178 </span>Arguments:
<span id="L179" class="LineNr">179 </span>oid
<span id="L180" class="LineNr">180 </span>   is a file opening identifier.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L181" class="LineNr">181 </span>first_ci
<span id="L182" class="LineNr">182 </span>   is the control interval number of the first control interval of the
<span id="L183" class="LineNr">183 </span>   set whose physical space is to be freed.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L184" class="LineNr">184 </span>n_ci
<span id="L185" class="LineNr">185 </span>   is the number of consecutive control intervals whose physical space
<span id="L186" class="LineNr">186 </span>   is to be freed.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L187" class="LineNr">187 </span>code
<span id="L188" class="LineNr">188 </span>   is a standard status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span> If it is
<span id="L189" class="LineNr">189 </span>   dm_error_$ci_already_free, the operation can still be considered a
<span id="L190" class="LineNr">190 </span>   success.
<span id="L191" class="LineNr">191 </span>
<span id="L192" class="LineNr">192 </span>
<span id="L193" class="LineNr">193 </span>Access required:
<span id="L194" class="LineNr">194 </span>The user must have write access to the file.
<span id="L195" class="LineNr">195 </span>
<span id="L196" class="LineNr">196 </span>
<span id="L197" class="LineNr">197 </span>Notes:  If the file is protected, the caller must be in transaction
<span id="L198" class="LineNr">198 </span>mode and the free operation is done under the auspices of the integrity
<span id="L199" class="LineNr">199 </span>services.  If the transaction aborts, the control intervals are
<span id="L200" class="LineNr">200 </span>reallocated and their contents restored.
<span id="L201" class="LineNr">201 </span>
<span id="L202" class="LineNr">202 </span>
<span id="L203" class="LineNr">203 </span>:Entry:  get:  03/15/85 file_manager_$get
<span id="L204" class="LineNr">204 </span>
<span id="L205" class="LineNr">205 </span>
<span id="L206" class="LineNr">206 </span>Function:  This entry point reads data from a control interval.  The
<span id="L207" class="LineNr">207 </span>caller may specify one or several parts.  Each part is described by its
<span id="L208" class="LineNr">208 </span>byte offset relative to the beginning of the addressable portion of the
<span id="L209" class="LineNr">209 </span>control interval and its length in bytes.  Each part has a pointer to a
<span id="L210" class="LineNr">210 </span>buffer provided by the caller.
<span id="L211" class="LineNr">211 </span>
<span id="L212" class="LineNr">212 </span>If the control interval does not exist, the buffers provided by the
<span id="L213" class="LineNr">213 </span>caller are filled with zeros and code is set to zero.
<span id="L214" class="LineNr">214 </span>
<span id="L215" class="LineNr">215 </span>
<span id="L216" class="LineNr">216 </span>Syntax:
<span id="L217" class="LineNr">217 </span>declare file_manager_$get entry <span class="textRainbow_lv0_p0">(</span>bit<span class="textRainbow_lv1_p0">(</span>36<span class="textRainbow_lv1_p0">)</span> aligned<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>27<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span>
<span id="L218" class="LineNr">218 </span>     fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L219" class="LineNr">219 </span>call file_manager_$get <span class="textRainbow_lv0_p0">(</span>oid<span class="textRainbow_lv0_o0">,</span> ci_num<span class="textRainbow_lv0_o0">,</span> ci_parts_ptr<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L220" class="LineNr">220 </span>
<span id="L221" class="LineNr">221 </span>
<span id="L222" class="LineNr">222 </span>Arguments:
<span id="L223" class="LineNr">223 </span>oid
<span id="L224" class="LineNr">224 </span>   is a file opening identifier.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L225" class="LineNr">225 </span>ci_num
<span id="L226" class="LineNr">226 </span>   is a control interval number.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L227" class="LineNr">227 </span>ci_parts_ptr
<span id="L228" class="LineNr">228 </span>   points to the ci_parts structure declared in dm_ci_parts.incl.pl1.
<span id="L229" class="LineNr">229 </span>   <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L230" class="LineNr">230 </span>code
<span id="L231" class="LineNr">231 </span>   is a standard status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L232" class="LineNr">232 </span>
<span id="L233" class="LineNr">233 </span>
<span id="L234" class="LineNr">234 </span>Notes:  If the file is protected, the process must be in transaction
<span id="L235" class="LineNr">235 </span>mode, and unless no_concurrency is specified, get locks the control
<span id="L236" class="LineNr">236 </span>interval in share mode.  It is kept locked until the end of the
<span id="L237" class="LineNr">237 </span>transaction.  This assures that no other transaction can put anything
<span id="L238" class="LineNr">238 </span>into the control interval, free it, or delete the file during the
<span id="L239" class="LineNr">239 </span>current transaction.  If the control interval is locked in exclusive
<span id="L240" class="LineNr">240 </span>mode by another transaction, get waits until it finishes.  If waiting
<span id="L241" class="LineNr">241 </span>is pointless because the current transaction is deadlocked with another
<span id="L242" class="LineNr">242 </span>transaction, the transaction_deadlock condition is signaled.
<span id="L243" class="LineNr">243 </span>
<span id="L244" class="LineNr">244 </span>
<span id="L245" class="LineNr">245 </span>Access required:
<span id="L246" class="LineNr">246 </span>The calling process must have read access to call the get entry.
<span id="L247" class="LineNr">247 </span>
<span id="L248" class="LineNr">248 </span>
<span id="L249" class="LineNr">249 </span>:Entry:  get_ci_header:  03/15/85 file_manager_$get_ci_header
<span id="L250" class="LineNr">250 </span>
<span id="L251" class="LineNr">251 </span>
<span id="L252" class="LineNr">252 </span>Function: This entry reads the 4-word control interval header.  The
<span id="L253" class="LineNr">253 </span>header tells whether a control interval is allocated when it was last
<span id="L254" class="LineNr">254 </span>modified, and what the unique identifier of the DM file is.
<span id="L255" class="LineNr">255 </span>
<span id="L256" class="LineNr">256 </span>Protection and access are the same as for the get entry.
<span id="L257" class="LineNr">257 </span>
<span id="L258" class="LineNr">258 </span>If the control interval does not exist, this entry returns the header
<span id="L259" class="LineNr">259 </span>that it would have had, with zero in the time_modified field and code
<span id="L260" class="LineNr">260 </span>set to zero.  It does not create the control interval.
<span id="L261" class="LineNr">261 </span>
<span id="L262" class="LineNr">262 </span>
<span id="L263" class="LineNr">263 </span>Syntax:
<span id="L264" class="LineNr">264 </span>declare file_manager_$get_ci_header entry <span class="textRainbow_lv0_p0">(</span>bit<span class="textRainbow_lv1_p0">(</span>36<span class="textRainbow_lv1_p0">)</span> aligned<span class="textRainbow_lv0_o0">,</span> fixed
<span id="L265" class="LineNr">265 </span>     bin<span class="textRainbow_lv1_p0">(</span>27<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> 1 like ci_header aligned<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L266" class="LineNr">266 </span>call file_manager_$get_ci_header <span class="textRainbow_lv0_p0">(</span>oid<span class="textRainbow_lv0_o0">,</span> ci_num<span class="textRainbow_lv0_o0">,</span> ci_header<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L267" class="LineNr">267 </span>
<span id="L268" class="LineNr">268 </span>
<span id="L269" class="LineNr">269 </span>Arguments:
<span id="L270" class="LineNr">270 </span>oid
<span id="L271" class="LineNr">271 </span>   is a file opening identifier.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L272" class="LineNr">272 </span>ci_num
<span id="L273" class="LineNr">273 </span>   is a control interval number.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L274" class="LineNr">274 </span>ci_header
<span id="L275" class="LineNr">275 </span>   is the ci_header structure, declared in dm_ci_header.incl.pl1.
<span id="L276" class="LineNr">276 </span>   <span class="textRainbow_lv0_p0">(</span>Input/Output<span class="textRainbow_lv0_p0">)</span>
<span id="L277" class="LineNr">277 </span>code
<span id="L278" class="LineNr">278 </span>   is a standard status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L279" class="LineNr">279 </span>
<span id="L280" class="LineNr">280 </span>
<span id="L281" class="LineNr">281 </span>:Entry:  get_ci_ptr:  03/15/85 file_manager_$get_ci_ptr
<span id="L282" class="LineNr">282 </span>
<span id="L283" class="LineNr">283 </span>
<span id="L284" class="LineNr">284 </span>Function:  This entry point returns a pointer to the addressable
<span id="L285" class="LineNr">285 </span>portion of a control interval.  Pointers to control intervals should be
<span id="L286" class="LineNr">286 </span>used only in well defined and contained situations to enhance the
<span id="L287" class="LineNr">287 </span>performance of accessing data in a control interval for retrieval
<span id="L288" class="LineNr">288 </span>purposes.  This entry is helpful when it is known beforehand that
<span id="L289" class="LineNr">289 </span>several pieces of data are to be read from the same control interval,
<span id="L290" class="LineNr">290 </span>but they cannot be read by specifying several parts to the get entry
<span id="L291" class="LineNr">291 </span><span class="textRainbow_lv0_p0">(</span>e.g.<span class="textRainbow_lv0_o0">,</span> the offset of one is dependent on the value of another<span class="textRainbow_lv0_p0">)</span>.  Unlike
<span id="L292" class="LineNr">292 </span>other entries which get data, it is not valid to get a control interval
<span id="L293" class="LineNr">293 </span>pointer to a control interval that is not allocated.
<span id="L294" class="LineNr">294 </span>
<span id="L295" class="LineNr">295 </span>
<span id="L296" class="LineNr">296 </span>Syntax:
<span id="L297" class="LineNr">297 </span>declare file_manager_$get_ci_ptr entry <span class="textRainbow_lv0_p0">(</span>bit<span class="textRainbow_lv1_p0">(</span>36<span class="textRainbow_lv1_p0">)</span> aligned<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>27<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span>
<span id="L298" class="LineNr">298 </span>     ptr<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L299" class="LineNr">299 </span>call file_manager_$get_ci_ptr <span class="textRainbow_lv0_p0">(</span>oid<span class="textRainbow_lv0_o0">,</span> ci_num<span class="textRainbow_lv0_o0">,</span> ci_ptr<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L300" class="LineNr">300 </span>
<span id="L301" class="LineNr">301 </span>
<span id="L302" class="LineNr">302 </span>Arguments:
<span id="L303" class="LineNr">303 </span>oid
<span id="L304" class="LineNr">304 </span>   is a file opening identifier.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L305" class="LineNr">305 </span>ci_num
<span id="L306" class="LineNr">306 </span>   is a control interval number.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L307" class="LineNr">307 </span>ci_ptr
<span id="L308" class="LineNr">308 </span>   points to the addressable portion of the control interval.
<span id="L309" class="LineNr">309 </span>   <span class="textRainbow_lv0_p0">(</span>Input/Output<span class="textRainbow_lv0_p0">)</span> The addressable portion begins immediately after the
<span id="L310" class="LineNr">310 </span>   control interval header.  A null value is returned for this pointer
<span id="L311" class="LineNr">311 </span>   if there is a error and the returned code is not zero.
<span id="L312" class="LineNr">312 </span>code
<span id="L313" class="LineNr">313 </span>   is a standard status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span> It can be
<span id="L314" class="LineNr">314 </span>   dm_error_$ci_not_allocated if the specified control interval has not
<span id="L315" class="LineNr">315 </span>   been allocated.  ci_ptr is set to null.
<span id="L316" class="LineNr">316 </span>
<span id="L317" class="LineNr">317 </span>
<span id="L318" class="LineNr">318 </span>Notes:  In order to make it possible to look at control intervals via a
<span id="L319" class="LineNr">319 </span>pointer, the create entry sets the ring brackets on file components to:
<span id="L320" class="LineNr">320 </span>     &lt;DM-ring&gt;,&lt;validation-level&gt;,&lt;validation-level&gt;.
<span id="L321" class="LineNr">321 </span>If the file is protected, the process must be in transaction mode, and
<span id="L322" class="LineNr">322 </span>unless no_concurrency is specified, get_ci_ptr locks the control
<span id="L323" class="LineNr">323 </span>interval in share mode.  It is kept locked until the end of the
<span id="L324" class="LineNr">324 </span>transaction.  This assures that no other transaction can put anything
<span id="L325" class="LineNr">325 </span>into the control interval, free it, or delete the file during the
<span id="L326" class="LineNr">326 </span>current transaction.  If the control interval is locked in exclusive
<span id="L327" class="LineNr">327 </span>mode by another transaction, get_ci_ptr waits until it finishes.  If
<span id="L328" class="LineNr">328 </span>waiting is pointless because the current transaction is deadlocked with
<span id="L329" class="LineNr">329 </span>another transaction, the transaction_deadlock condition is signaled.
<span id="L330" class="LineNr">330 </span>
<span id="L331" class="LineNr">331 </span>If the control interval does not exist, an error code of value
<span id="L332" class="LineNr">332 </span>dm_error_$ci_not_allocated is returned.
<span id="L333" class="LineNr">333 </span>
<span id="L334" class="LineNr">334 </span>
<span id="L335" class="LineNr">335 </span>Access required:
<span id="L336" class="LineNr">336 </span>The calling process must have read access to call the get_ci_ptr entry.
<span id="L337" class="LineNr">337 </span>
<span id="L338" class="LineNr">338 </span>
<span id="L339" class="LineNr">339 </span>:Entry:  get_exclusive:  03/15/85 file_manager_$get_exclusive
<span id="L340" class="LineNr">340 </span>
<span id="L341" class="LineNr">341 </span>
<span id="L342" class="LineNr">342 </span>Function:  This entry point is the same as get entry except that it
<span id="L343" class="LineNr">343 </span>locks the control interval exclusively, preventing other transactions
<span id="L344" class="LineNr">344 </span>from even obtaining the share lock necessary to do a normal get
<span id="L345" class="LineNr">345 </span>operation.
<span id="L346" class="LineNr">346 </span>
<span id="L347" class="LineNr">347 </span>
<span id="L348" class="LineNr">348 </span>Syntax:
<span id="L349" class="LineNr">349 </span>declare file_manager_$get_exclusive entry <span class="textRainbow_lv0_p0">(</span>bit<span class="textRainbow_lv1_p0">(</span>36<span class="textRainbow_lv1_p0">)</span> aligned<span class="textRainbow_lv0_o0">,</span> fixed
<span id="L350" class="LineNr">350 </span>     bin<span class="textRainbow_lv1_p0">(</span>27<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L351" class="LineNr">351 </span>call file_manager_$get_exclusive <span class="textRainbow_lv0_p0">(</span>oid<span class="textRainbow_lv0_o0">,</span> ci_num<span class="textRainbow_lv0_o0">,</span> ci_parts_ptr<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L352" class="LineNr">352 </span>
<span id="L353" class="LineNr">353 </span>
<span id="L354" class="LineNr">354 </span>Arguments:
<span id="L355" class="LineNr">355 </span>oid
<span id="L356" class="LineNr">356 </span>   is a file opening identifier.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L357" class="LineNr">357 </span>ci_num
<span id="L358" class="LineNr">358 </span>   is a control interval number.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L359" class="LineNr">359 </span>ci_parts_ptr
<span id="L360" class="LineNr">360 </span>   points to the ci_parts structure declared in dm_ci_parts.incl.pl1.
<span id="L361" class="LineNr">361 </span>   <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L362" class="LineNr">362 </span>code
<span id="L363" class="LineNr">363 </span>   is a standard status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L364" class="LineNr">364 </span>
<span id="L365" class="LineNr">365 </span>
<span id="L366" class="LineNr">366 </span>Notes:  This entry is useful for applications that are going to do a
<span id="L367" class="LineNr">367 </span>put operation into the same control interval.
<span id="L368" class="LineNr">368 </span>
<span id="L369" class="LineNr">369 </span>Obtaining an exclusive lock on a control interval effectively reduces
<span id="L370" class="LineNr">370 </span>concurrency, so this entry should be used advisedly.
<span id="L371" class="LineNr">371 </span>
<span id="L372" class="LineNr">372 </span>
<span id="L373" class="LineNr">373 </span>:Entry:  get_stream:  03/15/85 file_manager_$get_stream
<span id="L374" class="LineNr">374 </span>
<span id="L375" class="LineNr">375 </span>
<span id="L376" class="LineNr">376 </span>Function:  This entry point returns a specified number of bytes from a
<span id="L377" class="LineNr">377 </span>DM file, given an opening identifier, a file offset, and a buffer in
<span id="L378" class="LineNr">378 </span>which to place the bytes.  This entry treats the DM file as a stream of
<span id="L379" class="LineNr">379 </span>bytes consisting of the concatenation of the addressable portion of all
<span id="L380" class="LineNr">380 </span>control intervals in the DM file.
<span id="L381" class="LineNr">381 </span>
<span id="L382" class="LineNr">382 </span>
<span id="L383" class="LineNr">383 </span>Syntax:
<span id="L384" class="LineNr">384 </span>declare file_manager_$get_stream entry <span class="textRainbow_lv0_p0">(</span>bit<span class="textRainbow_lv1_p0">(</span>36<span class="textRainbow_lv1_p0">)</span> aligned<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>48<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span>
<span id="L385" class="LineNr">385 </span>     ptr<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>21<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L386" class="LineNr">386 </span>call file_manager_$get_stream <span class="textRainbow_lv0_p0">(</span>oid<span class="textRainbow_lv0_o0">,</span> file_offset_in_bytes<span class="textRainbow_lv0_o0">,</span> buf_ptr<span class="textRainbow_lv0_o0">,</span>
<span id="L387" class="LineNr">387 </span>     buf_length_in_bytes<span class="textRainbow_lv0_p0">)</span>;
<span id="L388" class="LineNr">388 </span>
<span id="L389" class="LineNr">389 </span>
<span id="L390" class="LineNr">390 </span>Arguments:
<span id="L391" class="LineNr">391 </span>oid
<span id="L392" class="LineNr">392 </span>   is the opening identifier of the DM file to be read from.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L393" class="LineNr">393 </span>file_offset_in_bytes
<span id="L394" class="LineNr">394 </span>   is the offset given in bytes, from the beginning of the logical
<span id="L395" class="LineNr">395 </span>   address space of the DM file given in bytes with an offset of zero
<span id="L396" class="LineNr">396 </span>   representing the beginning of the file.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L397" class="LineNr">397 </span>buf_ptr
<span id="L398" class="LineNr">398 </span>   is a pointer to a buffer where the bytes read from the DM file may
<span id="L399" class="LineNr">399 </span>   be placed.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L400" class="LineNr">400 </span>buf_length_in_bytes
<span id="L401" class="LineNr">401 </span>   is the number of bytes that are to be read from the DM file.
<span id="L402" class="LineNr">402 </span>   <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L403" class="LineNr">403 </span>
<span id="L404" class="LineNr">404 </span>
<span id="L405" class="LineNr">405 </span>Notes:  If the DM file is protected, the process must be in transaction
<span id="L406" class="LineNr">406 </span>mode and unless concurrency is specified, get_stream locks in share
<span id="L407" class="LineNr">407 </span>mode the control intervals in which the specified stream of bytes
<span id="L408" class="LineNr">408 </span>resides.
<span id="L409" class="LineNr">409 </span>
<span id="L410" class="LineNr">410 </span>
<span id="L411" class="LineNr">411 </span>Access required:
<span id="L412" class="LineNr">412 </span>The calling process must have read access to the DM file to call the
<span id="L413" class="LineNr">413 </span>get_stream entry.
<span id="L414" class="LineNr">414 </span>
<span id="L415" class="LineNr">415 </span>
<span id="L416" class="LineNr">416 </span>:Entry:  lock_advice:  03/15/85 file_manager_$lock_advice
<span id="L417" class="LineNr">417 </span>
<span id="L418" class="LineNr">418 </span>
<span id="L419" class="LineNr">419 </span>Function:  This entry point permits applications to give the file
<span id="L420" class="LineNr">420 </span>manager advice about locking granularity.  For example, if an
<span id="L421" class="LineNr">421 </span>application is to modify every control interval in a file, it can
<span id="L422" class="LineNr">422 </span>request the file manager to lock the entire file and save the overhead
<span id="L423" class="LineNr">423 </span>of locking individual control intervals.
<span id="L424" class="LineNr">424 </span>
<span id="L425" class="LineNr">425 </span>
<span id="L426" class="LineNr">426 </span>Syntax:
<span id="L427" class="LineNr">427 </span>declare file_manager_$lock_advice entry <span class="textRainbow_lv0_p0">(</span>bit<span class="textRainbow_lv1_p0">(</span>36<span class="textRainbow_lv1_p0">)</span> aligned<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv0_o0">,</span>
<span id="L428" class="LineNr">428 </span>     fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L429" class="LineNr">429 </span>call file_manager_$lock_advice <span class="textRainbow_lv0_p0">(</span>oid<span class="textRainbow_lv0_o0">,</span> lock_mode<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L430" class="LineNr">430 </span>
<span id="L431" class="LineNr">431 </span>
<span id="L432" class="LineNr">432 </span>Arguments:
<span id="L433" class="LineNr">433 </span>oid
<span id="L434" class="LineNr">434 </span>   is a file opening identifier.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L435" class="LineNr">435 </span>lock_mode
<span id="L436" class="LineNr">436 </span>   is the finest and weakest lock mode to use on this file for the
<span id="L437" class="LineNr">437 </span>   remainder of the opening.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> It must be one of the five
<span id="L438" class="LineNr">438 </span>   following modes:  4 <span class="textRainbow_lv0_p0">(</span>LOCK_MODE_IS<span class="textRainbow_lv0_p0">)</span>, 5 <span class="textRainbow_lv0_p0">(</span>LOCK_MODE_IX<span class="textRainbow_lv0_p0">)</span>, 6
<span id="L439" class="LineNr">439 </span>   <span class="textRainbow_lv0_p0">(</span>LOCK_MODE_SIX<span class="textRainbow_lv0_p0">)</span>, 2 <span class="textRainbow_lv0_p0">(</span>LOCK_MODE_S<span class="textRainbow_lv0_p0">)</span>, or 3 <span class="textRainbow_lv0_p0">(</span>LOCK_MODE_X<span class="textRainbow_lv0_p0">)</span> which are
<span id="L440" class="LineNr">440 </span>   declared in dm_lock_modes.incl.pl1.
<span id="L441" class="LineNr">441 </span>code
<span id="L442" class="LineNr">442 </span>   is a standard status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L443" class="LineNr">443 </span>
<span id="L444" class="LineNr">444 </span>
<span id="L445" class="LineNr">445 </span>Notes:  Lock advice never abridges protection against concurrent file
<span id="L446" class="LineNr">446 </span>access by other processes.  If no lock advice is given, file manager
<span id="L447" class="LineNr">447 </span>uses the weakest lock necessary to provide concurrency protection, and
<span id="L448" class="LineNr">448 </span>the finest granularity available, which is the control interval.  Lock
<span id="L449" class="LineNr">449 </span>advice always causes file manager to use a stronger lock or coarser
<span id="L450" class="LineNr">450 </span>granularity than absolutely necessary.  This reduces concurrency in
<span id="L451" class="LineNr">451 </span>order to reduce locking overhead.
<span id="L452" class="LineNr">452 </span>
<span id="L453" class="LineNr">453 </span>Lock advice applies to protected files unless the no_concurrency
<span id="L454" class="LineNr">454 </span>attribute is present.  Since it is an attribute of the opening and not
<span id="L455" class="LineNr">455 </span>of the file, it can be given to any open file, regardless of whether a
<span id="L456" class="LineNr">456 </span>transaction is in progress.  The first time the file is referenced in
<span id="L457" class="LineNr">457 </span>each transaction, the advice tells the file manager what kind of a
<span id="L458" class="LineNr">458 </span>global file lock to acquire.  If the lock advice is given after the
<span id="L459" class="LineNr">459 </span>first time the file is referenced, it will not be used until the next
<span id="L460" class="LineNr">460 </span>transaction.  The lock advice is retained until it is changed, or the
<span id="L461" class="LineNr">461 </span>file is closed.
<span id="L462" class="LineNr">462 </span>
<span id="L463" class="LineNr">463 </span>
<span id="L464" class="LineNr">464 </span>The advice concerns the type of lock to use at the file level.  The
<span id="L465" class="LineNr">465 </span>only way to control the type of lock used on a control interval is to
<span id="L466" class="LineNr">466 </span>call get_exclusive instead of get.  If no advice is given, IS
<span id="L467" class="LineNr">467 </span><span class="textRainbow_lv0_p0">(</span>intention shared<span class="textRainbow_lv0_p0">)</span> is presumed.  IS is strong enough for get and
<span id="L468" class="LineNr">468 </span>get_ci_header which lock control intervals in S <span class="textRainbow_lv0_p0">(</span>share<span class="textRainbow_lv0_p0">)</span> mode.  Put,
<span id="L469" class="LineNr">469 </span>allocate, and free require that the file lock be upgraded to the
<span id="L470" class="LineNr">470 </span>stronger IX <span class="textRainbow_lv0_p0">(</span>intention exclusive<span class="textRainbow_lv0_p0">)</span> mode, because they lock control
<span id="L471" class="LineNr">471 </span>intervals in X <span class="textRainbow_lv0_p0">(</span>exclusive<span class="textRainbow_lv0_p0">)</span> mode.  Create and delete lock the file in X
<span id="L472" class="LineNr">472 </span>mode, regardless.  If advice is given, then all operations lock the
<span id="L473" class="LineNr">473 </span>file in the advised mode unless it is too weak for the operation.  The
<span id="L474" class="LineNr">474 </span>SIX <span class="textRainbow_lv0_p0">(</span>shared and intention exclusive<span class="textRainbow_lv0_p0">)</span> mode means only lock the control
<span id="L475" class="LineNr">475 </span>intervals that are modified.  SIX saves the overhead of locking
<span id="L476" class="LineNr">476 </span>individual control intervals for get operations because it prevents
<span id="L477" class="LineNr">477 </span>other transactions from getting anything but an IS lock on the file.
<span id="L478" class="LineNr">478 </span>
<span id="L479" class="LineNr">479 </span>
<span id="L480" class="LineNr">480 </span>:Entry:  open:  03/15/85 file_manager_$open
<span id="L481" class="LineNr">481 </span>
<span id="L482" class="LineNr">482 </span>
<span id="L483" class="LineNr">483 </span>Function:  This entry point makes a DM file accessible within a
<span id="L484" class="LineNr">484 </span>process.  The file is specified by its pathname.  The file is assigned
<span id="L485" class="LineNr">485 </span>an opening identifier in the current process, by which it is designated
<span id="L486" class="LineNr">486 </span>in all subsequent calls to file_manager_.
<span id="L487" class="LineNr">487 </span>
<span id="L488" class="LineNr">488 </span>
<span id="L489" class="LineNr">489 </span>Syntax:
<span id="L490" class="LineNr">490 </span>declare file_manager_$open entry <span class="textRainbow_lv0_p0">(</span>char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> bit<span class="textRainbow_lv1_p0">(</span>36<span class="textRainbow_lv1_p0">)</span> aligned<span class="textRainbow_lv0_o0">,</span>
<span id="L491" class="LineNr">491 </span>     fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L492" class="LineNr">492 </span>call file_manager_$open <span class="textRainbow_lv0_p0">(</span>dir_path<span class="textRainbow_lv0_o0">,</span> entry_name<span class="textRainbow_lv0_o0">,</span> oid<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L493" class="LineNr">493 </span>
<span id="L494" class="LineNr">494 </span>
<span id="L495" class="LineNr">495 </span>Arguments:
<span id="L496" class="LineNr">496 </span>dir_path
<span id="L497" class="LineNr">497 </span>   is the absolute pathname of the directory which contains the file.
<span id="L498" class="LineNr">498 </span>   <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L499" class="LineNr">499 </span>entry_name
<span id="L500" class="LineNr">500 </span>   is the entry name of the file.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L501" class="LineNr">501 </span>oid
<span id="L502" class="LineNr">502 </span>   is the file opening identifier assigned to the file and returned to
<span id="L503" class="LineNr">503 </span>   the caller.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span> If it is not zero, it is usable, regardless of
<span id="L504" class="LineNr">504 </span>   code.
<span id="L505" class="LineNr">505 </span>code
<span id="L506" class="LineNr">506 </span>   is a standard status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span> If it is
<span id="L507" class="LineNr">507 </span>   dm_error_$file_already_open, the operation is considered successful
<span id="L508" class="LineNr">508 </span>   and oid is usable.
<span id="L509" class="LineNr">509 </span>
<span id="L510" class="LineNr">510 </span>
<span id="L511" class="LineNr">511 </span>Notes:  If the file was already opened in the current process, the open
<span id="L512" class="LineNr">512 </span>entry does not assign a new opening identifier, but rather returns the
<span id="L513" class="LineNr">513 </span>opening identifier that was already assigned and sets code to
<span id="L514" class="LineNr">514 </span>dm_error_$file_already_open.  The file manager keeps track of the
<span id="L515" class="LineNr">515 </span>number of opens and closes.  The opening identifier remains valid as
<span id="L516" class="LineNr">516 </span>long as there are more opens than closes.  If all subsystems within a
<span id="L517" class="LineNr">517 </span>process close a file the same number of times they open it, they will
<span id="L518" class="LineNr">518 </span>not invalidate each others openings.
<span id="L519" class="LineNr">519 </span>
<span id="L520" class="LineNr">520 </span>There is no requirement for the process to be in transaction mode when
<span id="L521" class="LineNr">521 </span>opening a file, protected or not.  Aborting a transaction has no effect
<span id="L522" class="LineNr">522 </span>on file openings, even if create_open was called and the create is
<span id="L523" class="LineNr">523 </span>rolled back.  Attempts to use such an opening will result in
<span id="L524" class="LineNr">524 </span>dm_error_$file_doesnt_exist.  The same thing happens if a file is
<span id="L525" class="LineNr">525 </span>opened and then deleted.  Close is the only operation allowed on a file
<span id="L526" class="LineNr">526 </span>which has been deleted.
<span id="L527" class="LineNr">527 </span>
<span id="L528" class="LineNr">528 </span>
<span id="L529" class="LineNr">529 </span>:Entry:  put:  03/15/85 file_manager_$put
<span id="L530" class="LineNr">530 </span>
<span id="L531" class="LineNr">531 </span>
<span id="L532" class="LineNr">532 </span>Function:  This entry point writes data into a control interval.  The
<span id="L533" class="LineNr">533 </span>caller can specify one or several parts of the control interval to be
<span id="L534" class="LineNr">534 </span>written.
<span id="L535" class="LineNr">535 </span>
<span id="L536" class="LineNr">536 </span>If the control interval does not exist, it is automatically allocated
<span id="L537" class="LineNr">537 </span>and the content of its addressable portion is initialized to zero.
<span id="L538" class="LineNr">538 </span>
<span id="L539" class="LineNr">539 </span>
<span id="L540" class="LineNr">540 </span>Syntax:
<span id="L541" class="LineNr">541 </span>declare file_manager_$put entry <span class="textRainbow_lv0_p0">(</span>bit<span class="textRainbow_lv1_p0">(</span>36<span class="textRainbow_lv1_p0">)</span> aligned<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>27<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span>
<span id="L542" class="LineNr">542 </span>     fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L543" class="LineNr">543 </span>call file_manager$put <span class="textRainbow_lv0_p0">(</span>oid<span class="textRainbow_lv0_o0">,</span> ci_num<span class="textRainbow_lv0_o0">,</span> ci_parts_ptr<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L544" class="LineNr">544 </span>
<span id="L545" class="LineNr">545 </span>
<span id="L546" class="LineNr">546 </span>Arguments:
<span id="L547" class="LineNr">547 </span>oid
<span id="L548" class="LineNr">548 </span>   is a file opening identifier.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L549" class="LineNr">549 </span>ci_num
<span id="L550" class="LineNr">550 </span>   is a control interval number.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L551" class="LineNr">551 </span>ci_parts_ptr
<span id="L552" class="LineNr">552 </span>   points to the ci_parts structure declared in dm_ci_parts.incl.pl1.
<span id="L553" class="LineNr">553 </span>   <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L554" class="LineNr">554 </span>code
<span id="L555" class="LineNr">555 </span>   is a standard status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L556" class="LineNr">556 </span>
<span id="L557" class="LineNr">557 </span>
<span id="L558" class="LineNr">558 </span>Notes:  If the file is protected, the process must be in transaction
<span id="L559" class="LineNr">559 </span>mode, and unless no_concurrency is specified, put locks the control
<span id="L560" class="LineNr">560 </span>interval in exclusive mode.  It is kept locked until the end of the
<span id="L561" class="LineNr">561 </span>transaction.  This assures that no other transaction can put anything
<span id="L562" class="LineNr">562 </span>into the control interval, get anything from it, free it, or delete the
<span id="L563" class="LineNr">563 </span>file during the current transaction.  If the control interval is locked
<span id="L564" class="LineNr">564 </span>by another transaction, the put operation must wait until it finishes.
<span id="L565" class="LineNr">565 </span>If waiting is pointless because the current transaction is deadlocked
<span id="L566" class="LineNr">566 </span>with another transaction, the transaction_deadlock condition is
<span id="L567" class="LineNr">567 </span>signaled.
<span id="L568" class="LineNr">568 </span>
<span id="L569" class="LineNr">569 </span>Unless the file is unprotected or has the no_rollback attribute, a put
<span id="L570" class="LineNr">570 </span>operation causes a before image of data in the control interval to be
<span id="L571" class="LineNr">571 </span>journalized before actually modifying it.  If the transaction should
<span id="L572" class="LineNr">572 </span>abort, the before journal manager will undo its modifications by
<span id="L573" class="LineNr">573 </span>restoring the before images.
<span id="L574" class="LineNr">574 </span>
<span id="L575" class="LineNr">575 </span>
<span id="L576" class="LineNr">576 </span>The modified control interval can not be written to disk until its
<span id="L577" class="LineNr">577 </span>before image is on disk, because there must be enough information on
<span id="L578" class="LineNr">578 </span>disk to roll back the transaction even if main memory fails.  If the
<span id="L579" class="LineNr">579 </span>modified control interval were written first and the system failed
<span id="L580" class="LineNr">580 </span>before the transaction finished and the content of main memory could
<span id="L581" class="LineNr">581 </span>not be flushed to disk, the modification could not be undone and
<span id="L582" class="LineNr">582 </span>rollback of the transaction would be incomplete.  The data management
<span id="L583" class="LineNr">583 </span>system holds modified control intervals in main memory until the
<span id="L584" class="LineNr">584 </span>associated before images are written to disk.  The Multics clock value
<span id="L585" class="LineNr">585 </span>in the control interval header is used for this purpose.
<span id="L586" class="LineNr">586 </span>
<span id="L587" class="LineNr">587 </span>
<span id="L588" class="LineNr">588 </span>The put request is rejected if either of the following is true:
<span id="L589" class="LineNr">589 </span>
<span id="L590" class="LineNr">590 </span>   - The user does not have write permission on the file.
<span id="L591" class="LineNr">591 </span>   - The file is protected but the process is not in a transaction
<span id="L592" class="LineNr">592 </span>     mode.
<span id="L593" class="LineNr">593 </span>
<span id="L594" class="LineNr">594 </span>
<span id="L595" class="LineNr">595 </span>:Entry:  put_stream:  03/15/85 file_manager_$put_stream
<span id="L596" class="LineNr">596 </span>
<span id="L597" class="LineNr">597 </span>
<span id="L598" class="LineNr">598 </span>Function:  This entry point writes a specified number of bytes in a DM
<span id="L599" class="LineNr">599 </span>file at a given offset in the logical address space.  This entry treats
<span id="L600" class="LineNr">600 </span>the DM file as a stream of bytes made up of the concatenation of the
<span id="L601" class="LineNr">601 </span>addressable portion of all control intervals in the DM file.
<span id="L602" class="LineNr">602 </span>
<span id="L603" class="LineNr">603 </span>
<span id="L604" class="LineNr">604 </span>Syntax:
<span id="L605" class="LineNr">605 </span>declare file_manager_$put_stream entry <span class="textRainbow_lv0_p0">(</span>bit<span class="textRainbow_lv1_p0">(</span>36<span class="textRainbow_lv1_p0">)</span> aligned<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>48<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span>
<span id="L606" class="LineNr">606 </span>     ptr<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>21<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L607" class="LineNr">607 </span>call file_manager_$put <span class="textRainbow_lv0_p0">(</span>oid<span class="textRainbow_lv0_o0">,</span> file_offset_in_bytes<span class="textRainbow_lv0_o0">,</span> buf_ptr<span class="textRainbow_lv0_o0">,</span>
<span id="L608" class="LineNr">608 </span>     buf_length_in_bytes<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L609" class="LineNr">609 </span>
<span id="L610" class="LineNr">610 </span>
<span id="L611" class="LineNr">611 </span>Arguments:
<span id="L612" class="LineNr">612 </span>oid
<span id="L613" class="LineNr">613 </span>   is the opening identifier of the DM file.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L614" class="LineNr">614 </span>file_offset_in_bytes
<span id="L615" class="LineNr">615 </span>   is the offset in bytes into the logical address space of the DM file
<span id="L616" class="LineNr">616 </span>   where the supplied bytes will be placed.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L617" class="LineNr">617 </span>buf_ptr
<span id="L618" class="LineNr">618 </span>   is a pointer to the buffer containing the bytes to be written to the
<span id="L619" class="LineNr">619 </span>   DM file.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L620" class="LineNr">620 </span>buf_length_in_bytes
<span id="L621" class="LineNr">621 </span>   is the number of bytes to be written into the DM file from the
<span id="L622" class="LineNr">622 </span>   buffer.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L623" class="LineNr">623 </span>code
<span id="L624" class="LineNr">624 </span>   is a standard system status code.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L625" class="LineNr">625 </span>
<span id="L626" class="LineNr">626 </span>
<span id="L627" class="LineNr">627 </span>Notes:  If the DM file is protected, the process must be in transaction
<span id="L628" class="LineNr">628 </span>mode, and unless concurrency is specified, put_stream locks the control
<span id="L629" class="LineNr">629 </span>intervals in which the specified stream of bytes resides.
<span id="L630" class="LineNr">630 </span>
<span id="L631" class="LineNr">631 </span>
<span id="L632" class="LineNr">632 </span>Access required:
<span id="L633" class="LineNr">633 </span>The calling process must have write access to the DM file to call the
<span id="L634" class="LineNr">634 </span>put_stream entry.
<span id="L635" class="LineNr">635 </span>
<span id="L636" class="LineNr">636 </span>
<span id="L637" class="LineNr">637 </span>:Entry:  raw_get:  03/15/85 file_manager_$raw_get
<span id="L638" class="LineNr">638 </span>
<span id="L639" class="LineNr">639 </span>
<span id="L640" class="LineNr">640 </span>Function:  This entry point resembles the get entry, except that it
<span id="L641" class="LineNr">641 </span>treats the file as if it were unprotected.  It does not require that
<span id="L642" class="LineNr">642 </span>the process be in transaction mode.
<span id="L643" class="LineNr">643 </span>
<span id="L644" class="LineNr">644 </span>
<span id="L645" class="LineNr">645 </span>Syntax:
<span id="L646" class="LineNr">646 </span>declare file_manager_$raw_get entry <span class="textRainbow_lv0_p0">(</span>bit<span class="textRainbow_lv1_p0">(</span>36<span class="textRainbow_lv1_p0">)</span> aligned<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>27<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span>
<span id="L647" class="LineNr">647 </span>     ptr<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L648" class="LineNr">648 </span>call file_manager_$raw_get <span class="textRainbow_lv0_p0">(</span>oid<span class="textRainbow_lv0_o0">,</span> ci_num<span class="textRainbow_lv0_o0">,</span> ci_parts_ptr<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L649" class="LineNr">649 </span>
<span id="L650" class="LineNr">650 </span>
<span id="L651" class="LineNr">651 </span>Arguments:
<span id="L652" class="LineNr">652 </span>oid
<span id="L653" class="LineNr">653 </span>   is a file opening identifier.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L654" class="LineNr">654 </span>ci_num
<span id="L655" class="LineNr">655 </span>   is a control interval number.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L656" class="LineNr">656 </span>ci_parts_ptr
<span id="L657" class="LineNr">657 </span>   points to a ci_parts structure declared in dm_ci_parts.incl.pl1.
<span id="L658" class="LineNr">658 </span>   <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L659" class="LineNr">659 </span>code
<span id="L660" class="LineNr">660 </span>   is a standard status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L661" class="LineNr">661 </span>
<span id="L662" class="LineNr">662 </span>
<span id="L663" class="LineNr">663 </span>:Entry:  raw_put:  03/15/85 file_manager_$raw_put
<span id="L664" class="LineNr">664 </span>
<span id="L665" class="LineNr">665 </span>
<span id="L666" class="LineNr">666 </span>Function:  This entry point resembles the put entry, except that it
<span id="L667" class="LineNr">667 </span>treats the file as if it were unprotected.  Also, the time_modified
<span id="L668" class="LineNr">668 </span>stamp in the control interval header is not updated.  This operation is
<span id="L669" class="LineNr">669 </span>intended for applications that need to update protected files in an
<span id="L670" class="LineNr">670 </span>unprotected manner.  It does not require that the process be in
<span id="L671" class="LineNr">671 </span>transaction mode.
<span id="L672" class="LineNr">672 </span>
<span id="L673" class="LineNr">673 </span>
<span id="L674" class="LineNr">674 </span>Syntax:
<span id="L675" class="LineNr">675 </span>declare file_manager_$raw_put entry <span class="textRainbow_lv0_p0">(</span>bit<span class="textRainbow_lv1_p0">(</span>36<span class="textRainbow_lv1_p0">)</span> aligned<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>27<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span>
<span id="L676" class="LineNr">676 </span>     ptr<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L677" class="LineNr">677 </span>call file_manager_$raw_put <span class="textRainbow_lv0_p0">(</span>oid<span class="textRainbow_lv0_o0">,</span> ci_num<span class="textRainbow_lv0_o0">,</span> ci_parts_ptr<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L678" class="LineNr">678 </span>
<span id="L679" class="LineNr">679 </span>
<span id="L680" class="LineNr">680 </span>Arguments:
<span id="L681" class="LineNr">681 </span>oid
<span id="L682" class="LineNr">682 </span>   is a file opening identifier.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L683" class="LineNr">683 </span>ci_num
<span id="L684" class="LineNr">684 </span>   is a control interval number.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L685" class="LineNr">685 </span>ci_parts_ptr
<span id="L686" class="LineNr">686 </span>   points to a ci_parts structure declared in dm_ci_parts.incl.pl1.
<span id="L687" class="LineNr">687 </span>   <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L688" class="LineNr">688 </span>code
<span id="L689" class="LineNr">689 </span>   is a standard status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L690" class="LineNr">690 </span>
<span id="L691" class="LineNr">691 </span>
<span id="L692" class="LineNr">692 </span>:Entry:  simple_get:  03/15/85 file_manager_$simple_get
<span id="L693" class="LineNr">693 </span>
<span id="L694" class="LineNr">694 </span>
<span id="L695" class="LineNr">695 </span>Function:  This entry point is used to get a sequence of bytes from a
<span id="L696" class="LineNr">696 </span>DM file, given an opening identifier, a control interval number, and
<span id="L697" class="LineNr">697 </span>control interval offset.  The sequence is placed in a caller-supplied
<span id="L698" class="LineNr">698 </span>buffer.  This entry point differs from the get entry in that it can
<span id="L699" class="LineNr">699 </span>only get bytes from one location within a control interval, and a
<span id="L700" class="LineNr">700 </span>ci_parts structure does not have to exist to make the call.
<span id="L701" class="LineNr">701 </span>
<span id="L702" class="LineNr">702 </span>
<span id="L703" class="LineNr">703 </span>Syntax:
<span id="L704" class="LineNr">704 </span>declare file_manager_$simple_get entry <span class="textRainbow_lv0_p0">(</span>bit<span class="textRainbow_lv1_p0">(</span>36<span class="textRainbow_lv1_p0">)</span> aligned<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>27<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span>
<span id="L705" class="LineNr">705 </span>     fixed bin<span class="textRainbow_lv1_p0">(</span>21<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>21<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L706" class="LineNr">706 </span>call file_manager_$simple_get <span class="textRainbow_lv0_p0">(</span>oid<span class="textRainbow_lv0_o0">,</span> ci_num<span class="textRainbow_lv0_o0">,</span> ci_offset_in_bytes<span class="textRainbow_lv0_o0">,</span>
<span id="L707" class="LineNr">707 </span>     buf_ptr<span class="textRainbow_lv0_o0">,</span> buf_length_in_bytes<span class="textRainbow_lv0_p0">)</span>;
<span id="L708" class="LineNr">708 </span>
<span id="L709" class="LineNr">709 </span>
<span id="L710" class="LineNr">710 </span>Arguments:
<span id="L711" class="LineNr">711 </span>oid
<span id="L712" class="LineNr">712 </span>   is the opening identifier of the DM file.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L713" class="LineNr">713 </span>ci_num
<span id="L714" class="LineNr">714 </span>   is the control interval in the DM file that contains the data to be
<span id="L715" class="LineNr">715 </span>   fetched.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L716" class="LineNr">716 </span>ci_offset_in_bytes
<span id="L717" class="LineNr">717 </span>   is the offset from the beginning of the control interval to the
<span id="L718" class="LineNr">718 </span>   beginning of the data, expressed in bytes.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L719" class="LineNr">719 </span>buf_ptr
<span id="L720" class="LineNr">720 </span>   is a pointer to a caller supplied buffer where the data is to be
<span id="L721" class="LineNr">721 </span>   placed.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L722" class="LineNr">722 </span>
<span id="L723" class="LineNr">723 </span>
<span id="L724" class="LineNr">724 </span>buf_length_in_bytes
<span id="L725" class="LineNr">725 </span>   is the length in bytes of the caller supplied buffer.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> This
<span id="L726" class="LineNr">726 </span>   also specifies the number of bytes to be fetched.  The sum of
<span id="L727" class="LineNr">727 </span>   ci_offset_in_bytes and buf_length_in_bytes must not exceed the
<span id="L728" class="LineNr">728 </span>   length of a control interval.
<span id="L729" class="LineNr">729 </span>code
<span id="L730" class="LineNr">730 </span>   is a standard system status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L731" class="LineNr">731 </span>
<span id="L732" class="LineNr">732 </span>
<span id="L733" class="LineNr">733 </span>:Entry:  simple_put:  03/15/85 file_manager_$simple_put
<span id="L734" class="LineNr">734 </span>
<span id="L735" class="LineNr">735 </span>
<span id="L736" class="LineNr">736 </span>Function:  This entry point places a given sequence of bytes into a DM
<span id="L737" class="LineNr">737 </span>file, given an open id, a control interval number, and a control
<span id="L738" class="LineNr">738 </span>interval offset.  This entry differs from the put entry point in that
<span id="L739" class="LineNr">739 </span>it places bytes only at one given location within a control interval,
<span id="L740" class="LineNr">740 </span>so no ci_parts structure is required.
<span id="L741" class="LineNr">741 </span>
<span id="L742" class="LineNr">742 </span>
<span id="L743" class="LineNr">743 </span>Syntax:
<span id="L744" class="LineNr">744 </span>declare file_manager_$simple_put entry <span class="textRainbow_lv0_p0">(</span>bit<span class="textRainbow_lv1_p0">(</span>36<span class="textRainbow_lv1_p0">)</span> aligned<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>27<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span>
<span id="L745" class="LineNr">745 </span>     fixed bin<span class="textRainbow_lv1_p0">(</span>21<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>21<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L746" class="LineNr">746 </span>call file_manager_$simple_put <span class="textRainbow_lv0_p0">(</span>oid<span class="textRainbow_lv0_o0">,</span> ci_num<span class="textRainbow_lv0_o0">,</span> ci_offset_in_bytes<span class="textRainbow_lv0_o0">,</span>
<span id="L747" class="LineNr">747 </span>     buf_ptr<span class="textRainbow_lv0_o0">,</span> buf_length_in_bytes<span class="textRainbow_lv0_p0">)</span>;
<span id="L748" class="LineNr">748 </span>
<span id="L749" class="LineNr">749 </span>
<span id="L750" class="LineNr">750 </span>Arguments:
<span id="L751" class="LineNr">751 </span>oid
<span id="L752" class="LineNr">752 </span>   is the opening identifier of the DM file.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L753" class="LineNr">753 </span>ci_num
<span id="L754" class="LineNr">754 </span>   is the control interval in the DM file where the data is to be
<span id="L755" class="LineNr">755 </span>   placed.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L756" class="LineNr">756 </span>ci_offset_in_bytes
<span id="L757" class="LineNr">757 </span>   is the offset from the beginning of the control interval to the
<span id="L758" class="LineNr">758 </span>   beginning of where the data is to be placed.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L759" class="LineNr">759 </span>buf_ptr
<span id="L760" class="LineNr">760 </span>   is a pointer to the buffer containing the data.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L761" class="LineNr">761 </span>buf_length_in_bytes
<span id="L762" class="LineNr">762 </span>   is the number of bytes that are to be placed into the DM file.
<span id="L763" class="LineNr">763 </span>   <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L764" class="LineNr">764 </span>code
<span id="L765" class="LineNr">765 </span>   is a standard system status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L766" class="LineNr">766 </span>
<span id="L767" class="LineNr">767 </span>
<span id="L768" class="LineNr">768 </span>:Entry:  status:  03/15/85 file_manager_$status
<span id="L769" class="LineNr">769 </span>
<span id="L770" class="LineNr">770 </span>
<span id="L771" class="LineNr">771 </span>Function:  This entry point returns status information on a DM file.
<span id="L772" class="LineNr">772 </span>
<span id="L773" class="LineNr">773 </span>
<span id="L774" class="LineNr">774 </span>Syntax:
<span id="L775" class="LineNr">775 </span>declare file_manager_$status entry <span class="textRainbow_lv0_p0">(</span>bit<span class="textRainbow_lv1_p0">(</span>36<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L776" class="LineNr">776 </span>call file_manager_$status <span class="textRainbow_lv0_p0">(</span>oid<span class="textRainbow_lv0_o0">,</span> file_status_ptr<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L777" class="LineNr">777 </span>
<span id="L778" class="LineNr">778 </span>
<span id="L779" class="LineNr">779 </span>Arguments:
<span id="L780" class="LineNr">780 </span>oid
<span id="L781" class="LineNr">781 </span>   is the opening identifier of the DM file.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L782" class="LineNr">782 </span>file_status_ptr
<span id="L783" class="LineNr">783 </span>   is a pointer to a file_status structure to be filled in by this
<span id="L784" class="LineNr">784 </span>   entry.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> See the include file dm_file_status.incl.pl1.
<span id="L785" class="LineNr">785 </span>code
<span id="L786" class="LineNr">786 </span>   is a standard system status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L787" class="LineNr">787 </span>
<span id="L788" class="LineNr">788 </span>
<span id="L789" class="LineNr">789 </span>Notes:
<span id="L790" class="LineNr">790 </span>The structure that lists the information returned by
<span id="L791" class="LineNr">791 </span>file_manager_$status to describe a DM file is declared in
<span id="L792" class="LineNr">792 </span>dm_file_status.incl.pl1.
<span id="L793" class="LineNr">793 </span>
<span id="L794" class="LineNr">794 </span>
<span id="L795" class="LineNr">795 </span>:Entry:  terminate_ci_ptr:  03/15/85 file_manager_$terminate_ci_ptr
<span id="L796" class="LineNr">796 </span>
<span id="L797" class="LineNr">797 </span>
<span id="L798" class="LineNr">798 </span>Function:  This entry point releases a control interval pointer to a
<span id="L799" class="LineNr">799 </span>specific control interval of a DM file retrieved through the get_ci_ptr
<span id="L800" class="LineNr">800 </span>entry point.  This entry must be called for each call to get_ci_ptr.
<span id="L801" class="LineNr">801 </span>
<span id="L802" class="LineNr">802 </span>
<span id="L803" class="LineNr">803 </span>Syntax:
<span id="L804" class="LineNr">804 </span>declare file_manager_$terminate_ci_ptr entry <span class="textRainbow_lv0_p0">(</span>bit<span class="textRainbow_lv1_p0">(</span>36<span class="textRainbow_lv1_p0">)</span> aligned<span class="textRainbow_lv0_o0">,</span> fixed
<span id="L805" class="LineNr">805 </span>     bin<span class="textRainbow_lv1_p0">(</span>27<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L806" class="LineNr">806 </span>call file_manager_$terminate_ci_ptr <span class="textRainbow_lv0_p0">(</span>oid<span class="textRainbow_lv0_o0">,</span> ci_num<span class="textRainbow_lv0_o0">,</span> ci_ptr<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L807" class="LineNr">807 </span>
<span id="L808" class="LineNr">808 </span>
<span id="L809" class="LineNr">809 </span>Arguments:
<span id="L810" class="LineNr">810 </span>oid
<span id="L811" class="LineNr">811 </span>   is the opening identifier of the DM file.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L812" class="LineNr">812 </span>ci_num
<span id="L813" class="LineNr">813 </span>   is the number of the control interval that ci_ptr points to.
<span id="L814" class="LineNr">814 </span>   <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L815" class="LineNr">815 </span>ci_ptr
<span id="L816" class="LineNr">816 </span>   is the control interval pointer to be terminated.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L817" class="LineNr">817 </span>code
<span id="L818" class="LineNr">818 </span>   is a standard system status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
</pre>
<script defer src='https://static.cloudflareinsights.com/beacon.min.js' data-cf-beacon='{"token": "4b6a131644014aa29fd88953508c3a3d"}'></script></body>
</html>
<!-- vim: set foldmethod=manual : -->
